
import { JSDOM } from 'jsdom';
import createDOMPurify = require('dompurify');

export type CustomElementHandling = createDOMPurify.Config['CUSTOM_ELEMENT_HANDLING'];

export function sanitize_html(html: string, custom_elements?: CustomElementHandling) : string {
	const { window } = new JSDOM('');
	const dom_purify = createDOMPurify(window as any as Window);
	return dom_purify.sanitize(html, {
		CUSTOM_ELEMENT_HANDLING: custom_elements,
		ALLOWED_TAGS: ['meta'],
		ALLOWED_ATTR: ['typeof', 'property', 'content'],
		ADD_URI_SAFE_ATTR: ['typeof']
	});
}
